<?php
/**
 * Copyright © 2016 X2i.
 */

namespace Gigya\GigyaIM\Api\Data;

/**
 * Interface GigyaCustomerAccountInterface
 *
 * Defines the internal Magento structure to hold data to use to update the Gigya service.
 *
 * @package Gigya\GigyaIM\Api\Data
 *
 */
interface GigyaCustomerAccountInterface
{
    /**
     * The Magento's internal entity id for this customer. May be null if it's a new customer.
     *
     * @return integer
     */
    function getEntityId();

    /**
     * The Magento's internal entity id for this customer. May be null if it's a new customer.
     *
     * @param $entityId integer
     * @return void
     */
    function setEntityId($entityId);

    /**
     * The Gigya's uid. Is generated by the Gigya service.
     *
     * Is null by default, when this account does not exists yet on Gigya, or when it's not synchronized yet with Magento.
     *
     * @return string
     */
    function getUid();

    /**
     * The Gigya's uid. The value shall be the one generated by the Gigya service.
     *
     * @param string $uid
     * @return void
     */
    function setUid($uid);

    /**
     * The email that will be used for login the Magento customer account.
     *
     * It's the preferred email, among all emails registered on this Gigya account, that is chosen as the login email for the corresponding Magento account.
     *
     * @return string
     */
    function getLoginEmail();

    /**
     * Set the email that will be used for login the Magento customer account.
     *
     * It shall be the email associated with this Magento account.
     *
     * @param $email
     * @return void
     */
    function setLoginEmail($email);
}